poll/accounts/urls.py
from django.conf.urls import url

from . import views

from .views import sign_up, sign_in, sign_out

app_name = 'accounts'

urlpatterns = [
    url(r'^sign-up/$', sign_up, name='sign_up'),
    url(r'^sign-in/$', sign_in, name='sign_in'),
    url(r'^sign-out/$', sign_out, name='sign_out'),
]

poll/poll/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from poll.views import home

urlpatterns = [
	url(r'^$', home, name='home'),
    url(r'^admin/', admin.site.urls),
    url(r'^polls/', include('polls.urls')),
    url(r'^accounts/', include('accounts.urls')),
]

poll/polls/urls.py
from django.conf.urls import url

from . import views

app_name = 'polls'

urlpatterns = [
    url(r'^$', views.IndexView.as_view(), name='index'),
    url(r'^(?P<pk>[0-9]+)/$', views.DetailView.as_view(), name='detail'),
    url(r'^(?P<pk>[0-9]+)/results/$', views.ResultsView.as_view(), name='results'),
    url(r'^(?P<question_id>[0-9]+)/vote/$', views.Vote.as_view(), name='vote'),
    url(r'^addquestion/$', views.AddQuestion.as_view(), name='addquestion'),
]

poll/accounts/models.py
from django.db import models

# Create your models here.

poll/polls/models.py
import datetime

from django.db import models
from django.utils.encoding import python_2_unicode_compatible
from django.utils import timezone

# Create your models here.
class Question(models.Model):
    question_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField('date published')

    def __str__(self):
        return self.question_text
    def was_published_recently(self):
        now = timezone.now()
        return now - datetime.timedelta(days=1) <= self.pub_date <= now


class Choice(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    choice_text = models.CharField(max_length=200)
    votes = models.IntegerField(default=0)

    def __str__(self):
        return self.choice_text

poll/accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import authenticate, login, logout
from django.urls import reverse

# Create your views here.
def sign_up(request):
    if request.user.is_authenticated:
        return redirect('/')
    context = {
        'message': 'sign up' 
    }
    form = UserCreationForm()
    if request.method == 'POST':
        form = UserCreationForm(request.POST)
        if form.is_valid():
            form.save()
            context['success'] = True
    else:
        form = UserCreationForm()
    context['form'] = form
    return render(request, 'sign_up.html', context=context)

def sign_in(request):
    if request.user.is_authenticated:
        return redirect('/')
    context = {
        'message': 'sign in' 
    }
    if request.method == 'POST':
        username = request.POST.get('username')
        password = request.POST.get('password')
        user = authenticate(username=username, password=password)
        if user:
            login(request, user)
            return redirect('/')
        else:
            context['error'] = 'Invalid Username or Password'
            context['username'] = username
    return render(request, 'sign_in.html', context=context)

def sign_out(request):
    logout(request)
    return redirect('accounts:sign_in')

poll/poll/views.py
from django.shortcuts import render

def home(request):
    return render(request, 'home.html');

poll/polls/views.py
from django.shortcuts import get_object_or_404, render, redirect
from django.http import HttpResponseRedirect, HttpResponse, JsonResponse
from django.urls import reverse
from django.views import generic
from django.utils import timezone

from .models import Choice, Question

# Create your views here.

class IndexView(generic.ListView):
    template_name = 'polls/index.html'
    context_object_name = 'latest_question_list'

    def get_queryset(self):
        """Return the last five published questions."""
        return Question.objects.filter(pub_date__lte=timezone.now()).order_by('-pub_date')[:10]

class DetailView(generic.DetailView):
    # for the viewing of choices and results
    model = Question
    template_name = 'polls/detail.html'

class ResultsView(generic.DetailView):
    model = Question
    template_name = 'polls/results.html'

class AddQuestion(generic.View):

    def post(self, request, *args, **kwargs):
        # function used for the addition of question
        question_text = request.POST.get('question_text')
        question = Question.objects.create(question_text = question_text, pub_date = timezone.now())
        i = 1;
        choicelist = []
        while(request.POST.get('c'+str(i))):
            choicelist.append(request.POST.get('c'+str(i)))
            i += 1

        for choice in choicelist:
            question.choice_set.create(choice_text=choice, votes=0)

        return HttpResponseRedirect(reverse('polls:index', args=()))

class Vote(generic.View):

    def post(self, request, question_id):
        # for the update of results after voting
        question = get_object_or_404(Question, pk=question_id)
        try:            
            selected_choice = question.choice_set.get(pk=request.POST['choice'])
        except (KeyError, Choice.DoesNotExist):
            return render(request, 'polls/detail.html', {
                'question' : question,
                'error_message' : "You didn't select a choice",
            })
        else:
            selected_choice.votes += 1
            selected_choice.save()
            choice_list = []
            choices = Choice.objects.filter(question=question).values('votes','choice_text');
            for choice in choices:
                choice_list.append(choice)
            choice_set = choice_list
            return JsonResponse({'status': 'success',
                                'choice_set': choice_set})

poll/accounts/templates/sign_in.html
{% extends 'base.html' %}

{% block content %}
    <style type="text/css">
        form {
            display: flex;
            flex-direction: column;
            justify-content: center;
            border: 1px solid grey;
            margin: 30px;
            padding: 50px;
        }
        form > * {
            margin: 10px;
        }
    </style>
    <form action="{% url 'accounts:sign_in' %}" method="POST">
        {{ error }}
        {% csrf_token %}
        <div>
            <label for="username">Username: </label>
            <input type="text" name="username" value="{{ username }}" autocomplete="off" id="username">
        </div>
        <div>
            <label for="password">Password: </label>
            <input type="password" name="password" id="password">
        </div>
        <button>Sign In</button>
    </form>
{% endblock %}

poll/accounts/templates/sign_up.html
{% extends 'base.html' %}

{% block content %}
    <style type="text/css">
        span, ul {
            display: none;
        }
        form {
            display: flex;
            flex-direction: column;
            border: 1px solid grey;
            margin: 30px;
            padding: 50px;
        }
    </style>
    {% if not success %}
        <form action="{% url 'accounts:sign_up' %}" method="POST">
            {% csrf_token %}
            {{ form.as_p }}
            <button>Sign Up</button>
        </form>
    {% else %}
        <p>Success <a href="{% url 'accounts:sign_in' %}">Sign In</a></p>
    {% endif %}
{% endblock %}

poll/poll/templates/base.html
{% load static %}

    <!-- calling of scripts, placed here for every template to inherit -->
    <script src= "{% static 'scripts/require.js'%}"></script>
    <script>
        require.config({
            baseUrl: "{% static 'scripts/' %}",
            paths: {
                'jquery' : "{% static 'scripts/jquery' %}",
                'choices' : "{% static 'scripts/choices' %}",
                'mustache' : "{% static 'scripts/mustache' %}"
            }
        });
    </script>
    <script src="{% static 'scripts/main.js' %}"></script>


    <link rel="stylesheet" type="text/css" href="{% static 'poll/style.css' %}" />

<!DOCTYPE html>
<html>
<head>
    <title>{{ "Halloo" }}</title>
</head>
<body>
    
    {% include "nav.html" %}

    {% block content %}{% endblock %}
    {% block jscripts %}{% endblock %}
    
</body>
</html>

poll/poll/templates/home.html
{% extends 'base.html' %}

{% block content %}
    <p>This is home</p>
    
{% endblock %}

poll/poll/templates/nav.html
<div class="nav">
    <ul class="navz">
        <li class="navzli"><a href="/" class="title"><h1>Polls</h1></a></li>
        {% if request.user.is_authenticated %}
        <li class="navzli"><a href="{% url 'polls:index' %}"><h1>See poll</h1></a></li>
        <li class="navzli"><a href="{% url 'accounts:sign_out' %}"><h1>Sign-out</h1></a></li>
        <h1>hello {{ request.user.username }} ;) </h1>
        {% else %}
        <li class="navzli"><a href="{% url 'accounts:sign_up' %}"><h1>Sign-up</h1></a></li>
        <li class="navzli"><a href="{% url 'accounts:sign_in' %}"><h1>Sign-in</h1></a></li>
        {% endif %}
    </ul>
</div>

poll/polls/templates/polls/detail.html
{% extends 'base.html' %}

{% block content %}
    <h1>{{ question.question_text }}</h1>

    {% if error_message %}<p><strong>{{ error_message }}</strong></p>{% endif %}
    <!-- choice list -->
    <form action="{% url 'polls:vote' question.id %}" method="post" id="vote">
    {% csrf_token %}
    {% for choice in question.choice_set.all %}
        <input type="radio" name="choice" id="choice{{ forloop.counter }}" value="{{ choice.id }}" />
        <label for="choice{{ forloop.counter }}">{{ choice.choice_text }}</label><br />
    {% endfor %}
    <input type="submit" value="Vote"/>
    </form>

    <h1>Results</h1>

    <ul class="results_list" id="results">
    {% for choice in question.choice_set.all %}
        <li>{{ choice.choice_text }} -- {{ choice.votes }} vote{{ choice.votes|pluralize }}</li>
    {% endfor %}
    </ul>

    <a href="{% url 'polls:detail' question.id %}">Vote again?</a>
{% endblock %}

poll/polls/templates/polls/index.html
{% extends 'base.html' %}

{% block content %}

    <body>
    {% if latest_question_list %}
        <ul>
        {% for question in latest_question_list %}
            <li><a href="{% url 'polls:detail' question.id %}">{{ question.question_text }}</a></li>
        {% endfor %}
        </ul>
    {% else %}
        <p>No polls are available.</p>
    {% endif %}

    <form action="{% url 'polls:addquestion' %}" method="POST">
        {% csrf_token %}
        
        Question: <input type="text" name="question_text"><br>
        Choices <br>

        <div id="container">
            <input type="text" name="c1"><br>
            <input type="text" name="c2"><br>
        </div>

        <button onclick="addChoice(choice)" type="button">Add Choice</button>

        <input type="submit" value="Add Question">
        <button id="practice" type="button">Sample</button>
    </form> 

    </body>
{% endblock %}

poll/polls/templates/polls/results.html
{% block content %}
    <h1>{{ question.question_text }}</h1>

    <ul>
    {% for choice in question.choice_set.all %}
        <li>{{ choice.choice_text }} -- {{ choice.votes }} vote{{ choice.votes|pluralize }}</li>
    {% endfor %}
    </ul>

    <a href="{% url 'polls:detail' question.id %}">Vote again?</a>
{% endblock %}